﻿using System;

namespace NameExtractor
{
    public class UnitTestDriver
    {
        //an object of tested class NameExtractor
        private NameExtractor nameExtractor;

        public UnitTestDriver()
        {
            nameExtractor = new NameExtractor();
        }
        
        private void CheckEquals(String Expected, String Actual, String Msg)
        {
            if (Expected != Actual)
            {
                String exceptionMsg = String.Format("{0} : expected: {1}, but was: {2}", Msg, Expected, Actual);
                Exception exception = new Exception(exceptionMsg);
                throw exception;
            }
        }

        //tests
        public void Test1()
        {
            nameExtractor.FullName = "Mr John Greench Brown, PhD";
            CheckEquals("Mr", nameExtractor.Title, "Title is not correct");
            CheckEquals("John", nameExtractor.FirstName, "First Name is not correct");
            CheckEquals("Greench", nameExtractor.MiddleName, "Middle Name is not correct");
            CheckEquals("Brown", nameExtractor.LastName, "Last Name is not correct");
            CheckEquals("PhD", nameExtractor.Suffix, "Suffix is not correct");
        }
        public void Test2()
        {
            nameExtractor.FullName = "John Brown";
            CheckEquals("", nameExtractor.Title, " Title is not correct");
            CheckEquals("John", nameExtractor.FirstName, " First Name is not correct");
            CheckEquals("", nameExtractor.MiddleName, " Middle Name is not correct");
            CheckEquals("Brown", nameExtractor.LastName, " Last Name is not correct");
            CheckEquals("", nameExtractor.Suffix, " Suffix is not correct");
            nameExtractor.FullName = "Mr.    John Brown";
            CheckEquals("Mr", nameExtractor.Title, " Title is not correct");
            CheckEquals("John", nameExtractor.FirstName, " First Name is not correct");
            CheckEquals("", nameExtractor.MiddleName, " Middle Name is not correct");
            CheckEquals("Brown", nameExtractor.LastName, " Last Name is not correct");
            CheckEquals("", nameExtractor.Suffix, " Suffix is not correct");

            nameExtractor.FullName = "John Brown, PhD";
            CheckEquals("John", nameExtractor.FirstName, " First Name is not correct");
            CheckEquals("Brown", nameExtractor.LastName, " Last Name is not correct");
            CheckEquals("PhD", nameExtractor.Suffix, " Suffix is not correct");
        }
    }
}
